"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments)).next());
    });
};
class DevicesCommand {
    constructor($stringParameter, $emulatorPlatformService, $options) {
        this.$stringParameter = $stringParameter;
        this.$emulatorPlatformService = $emulatorPlatformService;
        this.$options = $options;
        this.allowedParameters = [this.$stringParameter];
    }
    execute(args) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.$options.availableDevices) {
                return this.$emulatorPlatformService.listAvailableEmulators(args[0]);
            }
            return $injector.resolveCommand("device").execute(args);
        });
    }
}
exports.DevicesCommand = DevicesCommand;
$injector.registerCommand("devices", DevicesCommand);
