"use strict";
function RunTestCommandFactory(platform) {
    return function RunTestCommand($testExecutionService, $projectData) {
        $projectData.initializeProjectData();
        this.execute = (args) => $testExecutionService.startTestRunner(platform, $projectData);
        this.allowedParameters = [];
    };
}
$injector.registerCommand("dev-test|android", RunTestCommandFactory('android'));
$injector.registerCommand("dev-test|ios", RunTestCommandFactory('iOS'));
function RunKarmaTestCommandFactory(platform) {
    return function RunKarmaTestCommand($testExecutionService, $projectData) {
        $projectData.initializeProjectData();
        this.execute = (args) => $testExecutionService.startKarmaServer(platform, $projectData);
        this.allowedParameters = [];
    };
}
$injector.registerCommand("test|android", RunKarmaTestCommandFactory('android'));
$injector.registerCommand("test|ios", RunKarmaTestCommandFactory('iOS'));
