"use strict";
const lockfile = require("lockfile");
const path = require("path");
class LockFile {
    constructor($options) {
        this.$options = $options;
        this.lockFilePath = path.join(this.$options.profileDir, ".lock");
    }
    lock() {
        lockfile.lockSync(this.lockFilePath, LockFile.LOCK_PARAMS);
    }
    unlock() {
        lockfile.unlockSync(this.lockFilePath);
    }
    check() {
        return lockfile.checkSync(this.lockFilePath, LockFile.LOCK_PARAMS);
    }
}
LockFile.LOCK_EXPIRY_PERIOD_SEC = 180;
LockFile.LOCK_PARAMS = {
    retryWait: 100,
    retries: LockFile.LOCK_EXPIRY_PERIOD_SEC * 10,
    stale: LockFile.LOCK_EXPIRY_PERIOD_SEC * 1000
};
exports.LockFile = LockFile;
$injector.register("lockfile", LockFile);
