"use strict";
class PlatformsData {
    constructor($androidProjectService, $iOSProjectService) {
        this.platformsData = {};
        this.platformsData = {
            ios: $iOSProjectService,
            android: $androidProjectService
        };
    }
    get platformsNames() {
        return Object.keys(this.platformsData);
    }
    getPlatformData(platform, projectData) {
        return this.platformsData[platform.toLowerCase()] && this.platformsData[platform.toLowerCase()].getPlatformData(projectData);
    }
    get availablePlatforms() {
        return {
            iOS: "ios",
            Android: "android"
        };
    }
}
exports.PlatformsData = PlatformsData;
$injector.register("platformsData", PlatformsData);
